//class: download- handle download process


import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import java.text.*;
import java.awt.*;
import java.util.Timer;
import java.util.TimerTask;

// This class downloads a file from a URL.
class Download extends Observable implements Runnable {
	
	 Timer timer;
  // Max size of download buffer.
  private static final int MAX_BUFFER_SIZE = 1024;

  // These are the status names.
  public static final String STATUSES[] = {"Downloading",
    "Paused", "Complete", "Cancelled", "Error","Off"};
  
  
//   These are the off status   
  public static final String OFFTHIS[] = {"Inactive","Active"};

  // These are the status codes.
  public static final int DOWNLOADING = 0;
  public static final int PAUSED = 1;
  public static final int COMPLETE = 2;
  public static final int CANCELLED = 3;
  public static final int ERROR = 4;
  public static final int OFF = 1;
  public static final int SCHEDULE = 0;
  public static final int SCHEDULE1 = 1,SCHEDULE2 = 2,SCHEDULE3 = 3,SCHEDULE4 = 4,SCHEDULE5 = 5,
  SCHEDULE6 = 6,SCHEDULE7 = 7,SCHEDULE8 = 8,SCHEDULE9 = 9,SCHEDULE10 = 10,SCHEDULE11 = 11,
  SCHEDULE12 = 12,SCHEDULE13 = 13,SCHEDULE14 = 14,SCHEDULE15 = 15,SCHEDULE16 = 16,SCHEDULE17 = 17,
  SCHEDULE18 = 18,SCHEDULE19 = 19,SCHEDULE20 = 20,SCHEDULE21 = 21,SCHEDULE22 = 22,SCHEDULE23 = 23,
  SCHEDULE24 = 24,SCHEDULE25 = 25;
  // only one download process can be set
  public int active=0;
  
  // These are the off status   
  public static final String SCEHEDULETHIS[] = {"AM/PM","12.00 AM", "1.00 AM", "2.00 AM","3.00 AM","4.00 AM",
    "5.00 AM","6.00 AM","7.00 AM","8.00 AM","9.00 AM","10.00 AM","11.00 AM",
    "12.00 PM", "1.00 PM", "2.00 PM","3.00 PM","4.00 PM",
    "5.00 PM","6.00 PM","7.00 PM","8.00 PM","9.00 PM","10.00 PM","11.00 PM","Done!"};
  
  
  private URL url; // download URL
  private int size; // size of download in bytes
  private int downloaded; // number of bytes downloaded
  private int status; // current status of download
  private int scheduleList;//schedule download
  private int offAfter;// shutdown PC after

  // Constructor for Download.
  public Download(URL url) {
    this.url = url;
    size = -1;
    downloaded = 0;
    status = DOWNLOADING;

    // Begin the download.
    download();
  }

  // Get this download's URL.
  public String getUrl() {
    return url.toString();
  }

  // Get this download's size.
  public int getSize() {
    return size;
  }

  // Get this download's progress.
  public float getProgress() {
    return ((float) downloaded / size) * 100;
  }

  // Get this download's status.
  public int getStatus() {
    return status;
  }
  
  public int getSchedule() {
    return scheduleList;
  }
  
  public int getOff() {
    return offAfter;
  }

  // Pause this download.
  public void pause() {
    status = PAUSED;
    stateChanged();
    
  }

  // Resume this download.
  public void resume() {
    status = DOWNLOADING;
    stateChanged();
    download();
  }

  // Cancel this download.
  public void cancel() {
    status = CANCELLED;
    stateChanged();
  }
  // Schedule this download
  public void schedule() {
  Date now=new Date();
     DateFormat timeF = DateFormat.getTimeInstance(DateFormat.SHORT);
     String currTime = timeF.format(now);
     JDialog.setDefaultLookAndFeelDecorated(true);
  
  
    
    Object[] possibilities = {"12.00 AM", "1.00 AM", "2.00 AM","3.00 AM","4.00 AM",
    "5.00 AM","6.00 AM","7.00 AM","8.00 AM","9.00 AM","10.00 AM","11.00 AM",
    "12.00 PM", "1.00 PM", "2.00 PM","3.00 PM","4.00 PM",
    "5.00 PM","6.00 PM","7.00 PM","8.00 PM","9.00 PM","10.00 PM","11.00 PM"};
String timeSet = (String)JOptionPane.showInputDialog(
                    null,
                    "Choose Time:\n",
                    "Schedule Manager",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    possibilities,"null");

    if (timeSet.equals("12.00 AM")){
    scheduleList = SCHEDULE1;
    stateChanged();
    Reminder(1);   
    }
    else if (timeSet.equals("1.00 AM")){
    scheduleList = SCHEDULE2;





    stateChanged();
    Reminder(2);  
    } 
     else if (timeSet.equals("2.00 AM")){
    scheduleList = SCHEDULE3;
    stateChanged();
    Reminder(3);  
    } 
     else if (timeSet.equals("3.00 AM")){
    scheduleList = SCHEDULE4;
    stateChanged();
    Reminder(4);  
    }
     else if (timeSet.equals("4.00 AM")){
    scheduleList = SCHEDULE5;
    stateChanged();
    Reminder(5);  
    }
     else if (timeSet.equals("5.00 AM")){
    scheduleList = SCHEDULE6;
    stateChanged();
    Reminder(6);  
    } 
     else if (timeSet.equals("6.00 AM")){
    scheduleList = SCHEDULE7;
    stateChanged();
    Reminder(7);  
    } 
     else if (timeSet.equals("7.00 AM")){
    scheduleList = SCHEDULE8;
    stateChanged();
    Reminder(8);  
    }   
     else if (timeSet.equals("8.00 AM")){
    scheduleList = SCHEDULE9;
    stateChanged();
    Reminder(9);  
    } 
     else if (timeSet.equals("9.00 AM")){
    scheduleList = SCHEDULE10;
    stateChanged();
    Reminder(10);  
    } 
     else if (timeSet.equals("10.00 AM")){
    scheduleList = SCHEDULE11;
    stateChanged();
    Reminder(11);  
    } 
     else if (timeSet.equals("11.00 AM")){
    scheduleList = SCHEDULE12;
    stateChanged();
    Reminder(12);  
    } 
     else if (timeSet.equals("12.00 PM")){
    scheduleList = SCHEDULE13;
    stateChanged();
    Reminder(13);  
    } 
     else if (timeSet.equals("1.00 PM")){
    scheduleList = SCHEDULE14;
    stateChanged();
    Reminder(14);  
    } 
     else if (timeSet.equals("2.00 PM")){
    scheduleList = SCHEDULE15;
    stateChanged();
    Reminder(15);  
    } 
     else if (timeSet.equals("3.00 PM")){
    scheduleList = SCHEDULE16;
    stateChanged();
    Reminder(16);  
    }
     else if (timeSet.equals("4.00 PM")){
    scheduleList = SCHEDULE17;
    stateChanged();
    Reminder(17);  
    }
     else if (timeSet.equals("5.00 PM")){
    scheduleList = SCHEDULE18;
    stateChanged();
    Reminder(18);  
    } 
     else if (timeSet.equals("6.00 PM")){
    scheduleList = SCHEDULE19;
    stateChanged();
    Reminder(19);  
    } 
     else if (timeSet.equals("7.00 PM")){
    scheduleList = SCHEDULE20;
    stateChanged();
    Reminder(20);  
    }   
     else if (timeSet.equals("8.00 PM")){
    scheduleList = SCHEDULE21;
    stateChanged();
    Reminder(21);  
    } 
     else if (timeSet.equals("9.00 PM")){
    scheduleList = SCHEDULE22;
    stateChanged();
    Reminder(22);  
    } 
     else if (timeSet.equals("10.00 PM")){
    scheduleList = SCHEDULE23;
    stateChanged();
    Reminder(23);  
    } 
     else if (timeSet.equals("11.00 PM")){
    scheduleList = SCHEDULE24;
    stateChanged();
    Reminder(24);  
    } 
    else
    {
    scheduleList = SCHEDULE;
    stateChanged();	 
    }
  
  
   }
   
    public  void Reminder(int t) {
    	int sT= t;
        timer = new Timer();
        
        if(sT==1)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 00);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
         if(sT==2)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 01);
      calendar.set(Calendar.MINUTE, 13);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==3)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 02);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==4)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 03);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==5)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 04);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==6)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 05);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
          if(sT==7)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 06);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==8)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 07);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==9)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 8);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==10)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 9);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
         if(sT==11)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 10);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
         if(sT==12)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 11);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==13)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 12);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==14)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 13);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==15)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 14);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==16)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 15);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
          if(sT==17)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 16);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==18)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 17);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==19)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 18);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
          if(sT==20)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 19);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
        if(sT==21)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 20);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
         if(sT==22)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 21);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
        
         if(sT==23)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 22);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
         if(sT==24)
        {
        
      Calendar calendar = Calendar.getInstance();
      
      calendar.set(Calendar.HOUR_OF_DAY, 23);
      calendar.set(Calendar.MINUTE, 00);
      calendar.set(Calendar.SECOND, 0);

      Date time = calendar.getTime();
        System.out.println(""+time);
        timer.schedule(new RemindTask(),time);
        }
    }
   
   
   
      
    
  
  // Shutdown this pc after this download
  public void shutdown()throws IOException{//throws IOException
   
    	 Process p = Runtime.getRuntime().exec("shutdown -s -t 00"); 
 }
 
  public void off(){
  	if(active!=1){
  		offAfter = OFF;
    active=1;
    stateChanged();
  	}
  	else{
  		System.out.println("function lock");
  		
  	}
    
 }

  // Mark this download as having an error.
  private void error() {
    status = ERROR;
    stateChanged();
  }

  // Start or resume downloading.
  private void download() {
    Thread thread = new Thread(this);
    thread.start();
  }

  // Get file name portion of URL.
  private String getFileName(URL url) {
    String fileName = url.getFile();
    return fileName.substring(fileName.lastIndexOf('/') + 1);
  }

  // Download file.
  public void run() {
    RandomAccessFile file = null;
    InputStream stream = null;

    try {
      // Open connection to URL.
      HttpURLConnection connection =
        (HttpURLConnection) url.openConnection();

      // Specify what portion of file to download.
      connection.setRequestProperty("Range",
        "bytes=" + downloaded + "-");

      // Connect to server.
      connection.connect();

      // Make sure response code is in the 200 range.
      if (connection.getResponseCode() / 100 != 2) {
        error();
      }

      // Check for valid content length.
      int contentLength = connection.getContentLength();
      if (contentLength < 1) {
        error();
      }

      /* Set the size for this download if it
         hasn't been already set. */
      if (size == -1) {
        size = contentLength;
        stateChanged();
      }

      // Open file and seek to the end of it.
      file = new RandomAccessFile(getFileName(url), "rw");
      file.seek(downloaded);

      stream = connection.getInputStream();
      while (status == DOWNLOADING) {
        /* Size buffer according to how much of the
           file is left to download. */
        byte buffer[];
        if (size - downloaded > MAX_BUFFER_SIZE) {
          buffer = new byte[MAX_BUFFER_SIZE];
        } else {
          buffer = new byte[size - downloaded];
        }

        // Read from server into buffer.
        int read = stream.read(buffer);
        if (read == -1)
          break;

        // Write buffer to file.
        file.write(buffer, 0, read);
        downloaded += read;
        stateChanged();
      }

      //if the download process complete than shutdown pc now
      if ((status == DOWNLOADING)&&(active ==1)) {
        status = COMPLETE;
        stateChanged();
        shutdown();
      }
      else if (status == DOWNLOADING)
      {
      	status = COMPLETE;
        stateChanged();
      }
      
    } catch (Exception e) {
      error();
    } finally {
      // Close file.
      if (file != null) {
        try {
          file.close();
        } catch (Exception e) {}
      }

      // Close connection to server.
      if (stream != null) {
        try {
          stream.close();
        } catch (Exception e) {}
      }
    }
  }

  // Notify observers that this download's status has changed.
  private void stateChanged() {
    setChanged();
    notifyObservers();
  }
  
  class RemindTask extends TimerTask {
        public void run() {
        System.out.format("Time's up!%n");
        resume();
	    timer.cancel(); //Terminate the timer thread
	    scheduleList = SCHEDULE25;
        stateChanged();
        }
    }
}
