//class: DownloadManager- interface & main

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;

// The Download Manager.
public class DownloadManager extends JFrame
  implements Observer
{
	 
	
	
  // Add download text field.
  private JTextField addTextField;

  // Add JLabel
  private JLabel url;

  // Download table's data model.
  private DownloadsTableModel tableModel;

  // Table listing downloads.
  private JTable table;

  // These are the buttons for managing the selected download.
  private JButton pauseButton, resumeButton;
  private JButton cancelButton, clearButton;
  private JButton offButton, scheduleButton;


  // Currently selected download.
  private Download selectedDownload;

  // Flag for whether or not table selection is being cleared.
  private boolean clearing;

  // Constructor for Download Manager.
  public DownloadManager()
  {
	String laf = "";
  	laf = "com.sun.java.swing.plaf.basic.BasicTextUI";
		  try {
			  		UIManager.setLookAndFeel(laf);
					
			  		SwingUtilities.updateComponentTreeUI(this);
		  	  } catch (Exception excep) {
		  	  }
  	
  	
    // Set application title.
    setTitle("                                                  DownloadManager                                 ");
   
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    int x=screenSize.width/4;
    int y=screenSize.height/4;
	setLocation(x,y);
	
	
	

    // Set window size.
    setSize(600, 300);
    setBackground(new java.awt.Color(255,204,111));//255,204,100
    setResizable(true);
    
     

    // Handle window closing events.
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        actionExit();
      }
    });

    // Set up file menu.
    JMenuBar menuBar = new JMenuBar();
   // menuBar.setBackground(new java.awt.Color(255,20,147));//200,204,255
    menuBar.setForeground(Color.gray);
    JMenu fileMenu = new JMenu("File");
    JMenu themes = new JMenu("Skins");
    JMenu guide=new JMenu("Guide");
    JMenu about=new JMenu("Help");

    fileMenu.setMnemonic(KeyEvent.VK_F);
    guide.setMnemonic(KeyEvent.VK_G);
    about.setMnemonic(KeyEvent.VK_A);

    JMenuItem fileExitMenuItem = new JMenuItem("Exit",
      KeyEvent.VK_X);
    JMenuItem Themes1=new JMenuItem("windows");
    JMenuItem Themes2=new JMenuItem("Metal-yellow");
    JMenuItem Themes3=new JMenuItem("Motif");
	JMenuItem Themes4=new JMenuItem("Metal-orange");
    JMenuItem manual=new JMenuItem("Manual");
    JMenuItem info=new JMenuItem("Info");


    fileExitMenuItem.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionExit();
      }
    });


    Themes1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionThemes1();

      }
    });


    Themes2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionThemes2();

      }
    });
    
    Themes3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionThemes3();

      }
    });
    Themes4.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionThemes4();

      }
    });


     info.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionInfo();

      }
    });

     manual.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {

       actionManual();

      }
    });


    fileMenu.add(fileExitMenuItem);
    themes.add(Themes1);
    themes.add(Themes3);
    themes.add(Themes2);
	themes.add(Themes4);
    guide.add(manual);
    about.add(info);

    menuBar.add(fileMenu);
    menuBar.add(themes);
    menuBar.add(guide);
    menuBar.add(about);

    setJMenuBar(menuBar);




    // Set up add panel.
    JPanel addPanel = new JPanel();
    addPanel.setBackground(new java.awt.Color(200,204,255));//255,204,0
    addPanel.setBorder(
      BorderFactory.createTitledBorder(""));

    addPanel.setLayout(new BorderLayout());

    url=new JLabel("Url :");
    addPanel.add(url,BorderLayout.WEST);

    addTextField = new JTextField(30);
    addPanel.add(addTextField,BorderLayout.CENTER);
    JButton addButton = new JButton("    DownloadFile    ");
    addButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionAdd();
        repaint();
      }
    });
    addPanel.add(addButton,BorderLayout.EAST);

    // Set up Downloads table.
    tableModel = new DownloadsTableModel();
    table = new JTable(tableModel);
    table.getSelectionModel().addListSelectionListener(new
      ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        tableSelectionChanged();
      }
    });
    // Allow only one row at a time to be selected.
    table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    // Set up ProgressBar as renderer for progress column.
    ProgressRenderer renderer = new ProgressRenderer(0, 100);
    renderer.setStringPainted(true); // show progress text
    table.setDefaultRenderer(JProgressBar.class, renderer);
	this.setVisible(true);

    // Set table's row height large enough to fit JProgressBar.
    table.setRowHeight(
      (int) renderer.getPreferredSize().getHeight());

    // Set up downloads panel.
    JPanel downloadsPanel = new JPanel();
     downloadsPanel.setBackground(new java.awt.Color(200,204,255));//200,204,255
     //downloadsPanel.setForeground(Color.gray);
    downloadsPanel.setBorder(
      BorderFactory.createTitledBorder(""));
    downloadsPanel.setLayout(new BorderLayout());
    downloadsPanel.add(new JScrollPane(table),
      BorderLayout.CENTER);

    // Set up buttons panel.
    JPanel buttonsPanel = new JPanel();
    buttonsPanel.setLayout(new GridLayout(6,1));
    pauseButton = new JButton("Pause");
    pauseButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionPause();
      }
    });
   this.setVisible(true);
    pauseButton.setEnabled(false);
    buttonsPanel.add(pauseButton);
    resumeButton = new JButton("Resume");
    resumeButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionResume();
      }
    });
    resumeButton.setEnabled(false);
    buttonsPanel.add(resumeButton);
    cancelButton = new JButton("Cancel");
    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionCancel();
      }
    });
    cancelButton.setEnabled(false);
    buttonsPanel.add(cancelButton);
    clearButton = new JButton("Clear");
    clearButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionClear();
      }
    });


    clearButton.setEnabled(false);
    buttonsPanel.add(clearButton);

    scheduleButton=new JButton("Schedule");
     scheduleButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        actionSchedule();
      }
    });

    scheduleButton.setEnabled(false);
    buttonsPanel.add(scheduleButton);

    offButton=new JButton("shutdown PC");
    offButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
        actionOff();
      }
    });

    offButton.setEnabled(false);
    buttonsPanel.add(offButton);




    // Add panels to display.
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(addPanel, BorderLayout.NORTH);
    getContentPane().add(downloadsPanel, BorderLayout.CENTER);
    getContentPane().add(buttonsPanel,  BorderLayout.EAST);
  }

  // Exit this program.
  private void actionExit() {
    System.exit(0);
  }

  // Display info of this program.
  private void actionInfo() {

    JOptionPane.showMessageDialog(this,
        "Code by :: V.Bhavani Prasad,K.B.Santosh Reddy");
  }

  private void actionManual() {

    JOptionPane.showMessageDialog(this,
        "First insert the file url in the field and press DownloadFile to start the download process");

  }

  // Add a new download.
  private void actionAdd() {
    URL verifiedUrl = verifyUrl(addTextField.getText());
    if (verifiedUrl != null) {
      tableModel.addDownload(new Download(verifiedUrl));
      addTextField.setText(""); // reset add text field
    } else {
      JOptionPane.showMessageDialog(this,
        "Invalid Download URL", "Error",
        JOptionPane.ERROR_MESSAGE);
    }
  }

  // Verify download URL.
  private URL verifyUrl(String url) {
    // Only allow HTTP URLs.
    if (!url.toLowerCase().startsWith("http://"))
      return null;

    // Verify format of URL.
    URL verifiedUrl = null;
    try {
      verifiedUrl = new URL(url);
    } catch (Exception e) {
      return null;
    }

    // Make sure URL specifies a file.
    if (verifiedUrl.getFile().length() < 2)
      return null;

    return verifiedUrl;
  }

  // Called when table row selection changes.
  private void tableSelectionChanged() {
    /* Unregister from receiving notifications
       from the last selected download. */
    if (selectedDownload != null)
      selectedDownload.deleteObserver(DownloadManager.this);

    /* If not in the middle of clearing a download,
       set the selected download and register to
       receive notifications from it. */
    if (!clearing) {
      selectedDownload =
        tableModel.getDownload(table.getSelectedRow());
      selectedDownload.addObserver(DownloadManager.this);
      updateButtons();
   }
  this.setVisible(true);
  }

  // Pause the selected download.
  private void actionPause() {
    selectedDownload.pause();
    updateButtons();
  }

  // Resume the selected download.
  private void actionResume() {
    selectedDownload.resume();
    updateButtons();
  }

  // Cancel the selected download.
  private void actionCancel() {
    selectedDownload.cancel();
    updateButtons();
  }

  // Clear the selected download.
  private void actionClear() {
    clearing = true;
    tableModel.clearDownload(table.getSelectedRow());
    clearing = false;
    selectedDownload = null;
    updateButtons();
  }

  // Set schedule for selected download
  private void actionSchedule() {
    selectedDownload.schedule();
    updateButtons();
  }

  //Set off command after selected download finished
  private void actionOff() {
    selectedDownload.off();
    updateButtons();
  }




  /* Update each button's state based off of the
     currently selected download's status. */
  private void updateButtons() {
    if (selectedDownload != null) {
      int status = selectedDownload.getStatus();

      switch (status) {
        case Download.DOWNLOADING:
          pauseButton.setEnabled(true);
          resumeButton.setEnabled(false);
          cancelButton.setEnabled(true);
          clearButton.setEnabled(false);
          scheduleButton.setEnabled(false);
          offButton.setEnabled(true);
          break;
        case Download.PAUSED:
          pauseButton.setEnabled(false);
          resumeButton.setEnabled(true);
          cancelButton.setEnabled(true);
          clearButton.setEnabled(false);
          scheduleButton.setEnabled(true);
          offButton.setEnabled(true);
          break;
        case Download.ERROR:
          pauseButton.setEnabled(false);
          resumeButton.setEnabled(true);
          cancelButton.setEnabled(false);
          clearButton.setEnabled(true);
          scheduleButton.setEnabled(true);
          offButton.setEnabled(true);
          break;
        default: // COMPLETE or CANCELLED
          pauseButton.setEnabled(false);
          resumeButton.setEnabled(false);
          cancelButton.setEnabled(false);
          clearButton.setEnabled(true);
          scheduleButton.setEnabled(false);
          offButton.setEnabled(false);
      }
    } else {
      // No download is selected in table.
      pauseButton.setEnabled(false);
      resumeButton.setEnabled(false);
      cancelButton.setEnabled(false);
      clearButton.setEnabled(false);
      scheduleButton.setEnabled(false);
      offButton.setEnabled(false);
    }
  }

  /* Update is called when a Download notifies its
     observers of any changes. */
  public void update(Observable o, Object arg) {
    // Update buttons if the selected download has changed.
    if (selectedDownload != null && selectedDownload.equals(o))
      updateButtons();
  }
  
   public void actionThemes1() {
		  String laf = "";
			  laf = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		  try {
			  		UIManager.setLookAndFeel(laf);
			  		SwingUtilities.updateComponentTreeUI(this);
		  	  } catch (Exception excep) {
		  	  }
	  } 

	  public void actionThemes2() {
	 String laf = "";
   MetalTheme theme = new YellowTheme();
   // set the chosen theme

   MetalLookAndFeel.setCurrentTheme(theme);
   // Show name of the theme as window title

    try
   {
    UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
    SwingUtilities.updateComponentTreeUI(this);
   }
   catch(Exception e)
   {
    System.out.println(e);
    }
 }	  
	  public void actionThemes3() {
		  String laf = "";
			laf = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
		  try {
			  		UIManager.setLookAndFeel(laf);
			  		SwingUtilities.updateComponentTreeUI(this);
		  	  } catch (Exception excep) {
		  	  }
	  } 


     public void actionThemes4() {

  // user selects theme - Moody Blues 

   MetalTheme theme = new OrangeTheme();
   // set the chosen theme

   MetalLookAndFeel.setCurrentTheme(theme);
   // Show name of the theme as window title

    try
   {
    UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
    SwingUtilities.updateComponentTreeUI(this);
   }
   catch(Exception e)
   {
    System.out.println(e);
    }

   }


  // Run the Download Manager.
  public static void main(String[] args) {
  	// run program
    DownloadManager manager = new DownloadManager();
	manager.setVisible(true);
    
    
  }
}
